package edu.cmu.cs.l3.parse;
import edu.cmu.cs.l3.errormsg.ErrorMsg;
import edu.cmu.cs.l3.general.*;
import java.util.*;
/**
  This file is used by JLex to create lexer.lex.java, which
  contains the Yylex class for lexical analysis.
  References: Appel, Chapter 2: Lexical Analysis
*/


class Yylex implements Lexer {
	private final int YY_BUFFER_SIZE = 512;
	private final int YY_F = -1;
	private final int YY_NO_STATE = -1;
	private final int YY_NOT_ACCEPT = 0;
	private final int YY_START = 1;
	private final int YY_END = 2;
	private final int YY_NO_ANCHOR = 4;
	private final int YY_BOL = 128;
	private final int YY_EOF = 129;

private int comment_count = 0;
private int last_linenumber = 0;
private boolean inlinecomment = false;
private String filename = "";
private Hashtable outputted = new Hashtable();
private void newline() {
  errorMsg.newline(yychar);
}
private void err(int pos, String s) {
  errorMsg.error(pos,s);
}
private void err(String s) {
  err(yychar,s);
}
private void outfile(String s) {
  if (!s.startsWith("<") && outputted.get(s) == null) {
    outputted.put(s, new Integer(1));
    Globals.verbosePrintln("  --- " + s);
  }
}
private java_cup.runtime.Symbol tok(int kind, Object value) {
    return new java_cup.runtime.Symbol(kind, yychar, yychar+yylength(), value);
}
private ErrorMsg errorMsg;
Yylex(java.io.InputStream s, ErrorMsg e) {
  this(s);
  errorMsg=e;
}
	private java.io.BufferedReader yy_reader;
	private int yy_buffer_index;
	private int yy_buffer_read;
	private int yy_buffer_start;
	private int yy_buffer_end;
	private char yy_buffer[];
	private int yychar;
	private boolean yy_at_bol;
	private int yy_lexical_state;

	Yylex (java.io.Reader reader) {
		this ();
		if (null == reader) {
			throw (new Error("Error: Bad input stream initializer."));
		}
		yy_reader = new java.io.BufferedReader(reader);
	}

	Yylex (java.io.InputStream instream) {
		this ();
		if (null == instream) {
			throw (new Error("Error: Bad input stream initializer."));
		}
		yy_reader = new java.io.BufferedReader(new java.io.InputStreamReader(instream));
	}

	private Yylex () {
		yy_buffer = new char[YY_BUFFER_SIZE];
		yy_buffer_read = 0;
		yy_buffer_index = 0;
		yy_buffer_start = 0;
		yy_buffer_end = 0;
		yychar = 0;
		yy_at_bol = true;
		yy_lexical_state = YYINITIAL;
	}

	private boolean yy_eof_done = false;
	private final int FILENAME = 3;
	private final int YYINITIAL = 0;
	private final int COMMENT = 1;
	private final int LINECOMMENT = 2;
	private final int CPPDESC = 4;
	private final int yy_state_dtrans[] = {
		0,
		90,
		99,
		78,
		101
	};
	private void yybegin (int state) {
		yy_lexical_state = state;
	}
	private int yy_advance ()
		throws java.io.IOException {
		int next_read;
		int i;
		int j;

		if (yy_buffer_index < yy_buffer_read) {
			return yy_buffer[yy_buffer_index++];
		}

		if (0 != yy_buffer_start) {
			i = yy_buffer_start;
			j = 0;
			while (i < yy_buffer_read) {
				yy_buffer[j] = yy_buffer[i];
				++i;
				++j;
			}
			yy_buffer_end = yy_buffer_end - yy_buffer_start;
			yy_buffer_start = 0;
			yy_buffer_read = j;
			yy_buffer_index = j;
			next_read = yy_reader.read(yy_buffer,
					yy_buffer_read,
					yy_buffer.length - yy_buffer_read);
			if (-1 == next_read) {
				return YY_EOF;
			}
			yy_buffer_read = yy_buffer_read + next_read;
		}

		while (yy_buffer_index >= yy_buffer_read) {
			if (yy_buffer_index >= yy_buffer.length) {
				yy_buffer = yy_double(yy_buffer);
			}
			next_read = yy_reader.read(yy_buffer,
					yy_buffer_read,
					yy_buffer.length - yy_buffer_read);
			if (-1 == next_read) {
				return YY_EOF;
			}
			yy_buffer_read = yy_buffer_read + next_read;
		}
		return yy_buffer[yy_buffer_index++];
	}
	private void yy_move_end () {
		if (yy_buffer_end > yy_buffer_start &&
		    '\n' == yy_buffer[yy_buffer_end-1])
			yy_buffer_end--;
		if (yy_buffer_end > yy_buffer_start &&
		    '\r' == yy_buffer[yy_buffer_end-1])
			yy_buffer_end--;
	}
	private boolean yy_last_was_cr=false;
	private void yy_mark_start () {
		yychar = yychar
			+ yy_buffer_index - yy_buffer_start;
		yy_buffer_start = yy_buffer_index;
	}
	private void yy_mark_end () {
		yy_buffer_end = yy_buffer_index;
	}
	private void yy_to_mark () {
		yy_buffer_index = yy_buffer_end;
		yy_at_bol = (yy_buffer_end > yy_buffer_start) &&
		            ('\r' == yy_buffer[yy_buffer_end-1] ||
		             '\n' == yy_buffer[yy_buffer_end-1] ||
		             2028/*LS*/ == yy_buffer[yy_buffer_end-1] ||
		             2029/*PS*/ == yy_buffer[yy_buffer_end-1]);
	}
	private java.lang.String yytext () {
		return (new java.lang.String(yy_buffer,
			yy_buffer_start,
			yy_buffer_end - yy_buffer_start));
	}
	private int yylength () {
		return yy_buffer_end - yy_buffer_start;
	}
	private char[] yy_double (char buf[]) {
		int i;
		char newbuf[];
		newbuf = new char[2*buf.length];
		for (i = 0; i < buf.length; ++i) {
			newbuf[i] = buf[i];
		}
		return newbuf;
	}
	private final int YY_E_INTERNAL = 0;
	private final int YY_E_MATCH = 1;
	private java.lang.String yy_error_string[] = {
		"Error: Internal error.\n",
		"Error: Unmatched input.\n"
	};
	private void yy_error (int code,boolean fatal) {
		java.lang.System.out.print(yy_error_string[code]);
		java.lang.System.out.flush();
		if (fatal) {
			throw new Error("Fatal Error.\n");
		}
	}
	private int[][] unpackFromString(int size1, int size2, String st) {
		int colonIndex = -1;
		String lengthString;
		int sequenceLength = 0;
		int sequenceInteger = 0;

		int commaIndex;
		String workString;

		int res[][] = new int[size1][size2];
		for (int i= 0; i < size1; i++) {
			for (int j= 0; j < size2; j++) {
				if (sequenceLength != 0) {
					res[i][j] = sequenceInteger;
					sequenceLength--;
					continue;
				}
				commaIndex = st.indexOf(',');
				workString = (commaIndex==-1) ? st :
					st.substring(0, commaIndex);
				st = st.substring(commaIndex+1);
				colonIndex = workString.indexOf(':');
				if (colonIndex == -1) {
					res[i][j]=Integer.parseInt(workString);
					continue;
				}
				lengthString =
					workString.substring(colonIndex+1);
				sequenceLength=Integer.parseInt(lengthString);
				workString=workString.substring(0,colonIndex);
				sequenceInteger=Integer.parseInt(workString);
				res[i][j] = sequenceInteger;
				sequenceLength--;
			}
		}
		return res;
	}
	private int yy_acpt[] = {
		/* 0 */ YY_NOT_ACCEPT,
		/* 1 */ YY_NO_ANCHOR,
		/* 2 */ YY_NO_ANCHOR,
		/* 3 */ YY_NO_ANCHOR,
		/* 4 */ YY_NO_ANCHOR,
		/* 5 */ YY_NO_ANCHOR,
		/* 6 */ YY_NO_ANCHOR,
		/* 7 */ YY_NO_ANCHOR,
		/* 8 */ YY_NO_ANCHOR,
		/* 9 */ YY_NO_ANCHOR,
		/* 10 */ YY_NO_ANCHOR,
		/* 11 */ YY_NO_ANCHOR,
		/* 12 */ YY_NO_ANCHOR,
		/* 13 */ YY_NO_ANCHOR,
		/* 14 */ YY_NO_ANCHOR,
		/* 15 */ YY_NO_ANCHOR,
		/* 16 */ YY_NO_ANCHOR,
		/* 17 */ YY_NO_ANCHOR,
		/* 18 */ YY_NO_ANCHOR,
		/* 19 */ YY_NO_ANCHOR,
		/* 20 */ YY_NO_ANCHOR,
		/* 21 */ YY_NO_ANCHOR,
		/* 22 */ YY_NO_ANCHOR,
		/* 23 */ YY_NO_ANCHOR,
		/* 24 */ YY_NO_ANCHOR,
		/* 25 */ YY_NO_ANCHOR,
		/* 26 */ YY_NO_ANCHOR,
		/* 27 */ YY_NO_ANCHOR,
		/* 28 */ YY_NO_ANCHOR,
		/* 29 */ YY_NO_ANCHOR,
		/* 30 */ YY_NO_ANCHOR,
		/* 31 */ YY_NO_ANCHOR,
		/* 32 */ YY_NO_ANCHOR,
		/* 33 */ YY_NO_ANCHOR,
		/* 34 */ YY_NO_ANCHOR,
		/* 35 */ YY_NO_ANCHOR,
		/* 36 */ YY_NO_ANCHOR,
		/* 37 */ YY_NO_ANCHOR,
		/* 38 */ YY_NO_ANCHOR,
		/* 39 */ YY_NO_ANCHOR,
		/* 40 */ YY_NO_ANCHOR,
		/* 41 */ YY_NO_ANCHOR,
		/* 42 */ YY_NO_ANCHOR,
		/* 43 */ YY_NO_ANCHOR,
		/* 44 */ YY_NO_ANCHOR,
		/* 45 */ YY_NO_ANCHOR,
		/* 46 */ YY_NO_ANCHOR,
		/* 47 */ YY_NO_ANCHOR,
		/* 48 */ YY_NO_ANCHOR,
		/* 49 */ YY_NO_ANCHOR,
		/* 50 */ YY_NO_ANCHOR,
		/* 51 */ YY_NO_ANCHOR,
		/* 52 */ YY_NO_ANCHOR,
		/* 53 */ YY_NO_ANCHOR,
		/* 54 */ YY_NO_ANCHOR,
		/* 55 */ YY_NO_ANCHOR,
		/* 56 */ YY_NO_ANCHOR,
		/* 57 */ YY_NO_ANCHOR,
		/* 58 */ YY_NO_ANCHOR,
		/* 59 */ YY_NO_ANCHOR,
		/* 60 */ YY_NO_ANCHOR,
		/* 61 */ YY_NO_ANCHOR,
		/* 62 */ YY_NO_ANCHOR,
		/* 63 */ YY_NO_ANCHOR,
		/* 64 */ YY_NO_ANCHOR,
		/* 65 */ YY_NO_ANCHOR,
		/* 66 */ YY_NO_ANCHOR,
		/* 67 */ YY_NO_ANCHOR,
		/* 68 */ YY_NO_ANCHOR,
		/* 69 */ YY_NO_ANCHOR,
		/* 70 */ YY_NO_ANCHOR,
		/* 71 */ YY_NO_ANCHOR,
		/* 72 */ YY_NO_ANCHOR,
		/* 73 */ YY_NO_ANCHOR,
		/* 74 */ YY_NO_ANCHOR,
		/* 75 */ YY_NO_ANCHOR,
		/* 76 */ YY_NO_ANCHOR,
		/* 77 */ YY_NO_ANCHOR,
		/* 78 */ YY_NO_ANCHOR,
		/* 79 */ YY_NO_ANCHOR,
		/* 80 */ YY_NO_ANCHOR,
		/* 81 */ YY_NO_ANCHOR,
		/* 82 */ YY_NO_ANCHOR,
		/* 83 */ YY_NO_ANCHOR,
		/* 84 */ YY_NO_ANCHOR,
		/* 85 */ YY_NOT_ACCEPT,
		/* 86 */ YY_NO_ANCHOR,
		/* 87 */ YY_NO_ANCHOR,
		/* 88 */ YY_NO_ANCHOR,
		/* 89 */ YY_NO_ANCHOR,
		/* 90 */ YY_NOT_ACCEPT,
		/* 91 */ YY_NO_ANCHOR,
		/* 92 */ YY_NO_ANCHOR,
		/* 93 */ YY_NO_ANCHOR,
		/* 94 */ YY_NOT_ACCEPT,
		/* 95 */ YY_NO_ANCHOR,
		/* 96 */ YY_NO_ANCHOR,
		/* 97 */ YY_NOT_ACCEPT,
		/* 98 */ YY_NO_ANCHOR,
		/* 99 */ YY_NOT_ACCEPT,
		/* 100 */ YY_NO_ANCHOR,
		/* 101 */ YY_NOT_ACCEPT,
		/* 102 */ YY_NO_ANCHOR,
		/* 103 */ YY_NO_ANCHOR,
		/* 104 */ YY_NO_ANCHOR,
		/* 105 */ YY_NO_ANCHOR,
		/* 106 */ YY_NO_ANCHOR,
		/* 107 */ YY_NO_ANCHOR,
		/* 108 */ YY_NO_ANCHOR,
		/* 109 */ YY_NO_ANCHOR,
		/* 110 */ YY_NO_ANCHOR,
		/* 111 */ YY_NO_ANCHOR,
		/* 112 */ YY_NO_ANCHOR,
		/* 113 */ YY_NO_ANCHOR,
		/* 114 */ YY_NO_ANCHOR,
		/* 115 */ YY_NO_ANCHOR,
		/* 116 */ YY_NO_ANCHOR,
		/* 117 */ YY_NO_ANCHOR,
		/* 118 */ YY_NO_ANCHOR,
		/* 119 */ YY_NO_ANCHOR,
		/* 120 */ YY_NO_ANCHOR,
		/* 121 */ YY_NO_ANCHOR,
		/* 122 */ YY_NO_ANCHOR,
		/* 123 */ YY_NO_ANCHOR,
		/* 124 */ YY_NO_ANCHOR,
		/* 125 */ YY_NO_ANCHOR,
		/* 126 */ YY_NO_ANCHOR,
		/* 127 */ YY_NO_ANCHOR,
		/* 128 */ YY_NO_ANCHOR,
		/* 129 */ YY_NO_ANCHOR,
		/* 130 */ YY_NO_ANCHOR,
		/* 131 */ YY_NO_ANCHOR,
		/* 132 */ YY_NO_ANCHOR,
		/* 133 */ YY_NO_ANCHOR,
		/* 134 */ YY_NO_ANCHOR,
		/* 135 */ YY_NO_ANCHOR,
		/* 136 */ YY_NO_ANCHOR,
		/* 137 */ YY_NO_ANCHOR,
		/* 138 */ YY_NO_ANCHOR,
		/* 139 */ YY_NO_ANCHOR,
		/* 140 */ YY_NO_ANCHOR,
		/* 141 */ YY_NO_ANCHOR,
		/* 142 */ YY_NO_ANCHOR,
		/* 143 */ YY_NO_ANCHOR,
		/* 144 */ YY_NO_ANCHOR,
		/* 145 */ YY_NO_ANCHOR,
		/* 146 */ YY_NO_ANCHOR,
		/* 147 */ YY_NO_ANCHOR,
		/* 148 */ YY_NO_ANCHOR,
		/* 149 */ YY_NO_ANCHOR,
		/* 150 */ YY_NO_ANCHOR,
		/* 151 */ YY_NO_ANCHOR,
		/* 152 */ YY_NO_ANCHOR,
		/* 153 */ YY_NO_ANCHOR,
		/* 154 */ YY_NO_ANCHOR,
		/* 155 */ YY_NO_ANCHOR,
		/* 156 */ YY_NO_ANCHOR,
		/* 157 */ YY_NO_ANCHOR,
		/* 158 */ YY_NO_ANCHOR
	};
	private int yy_cmap[] = unpackFromString(1,130,
"53:8,2:2,1,53:2,2,53:18,55,31,54,49,56,12,28,53,5,6,8,7,27,9,32,10,50:10,26" +
",14,36,11,33,56:2,51:11,39,51,37,51:6,38,51:5,41,53,42,30,52,53,25,40,35,46" +
",16,21,47,45,20,51,48,22,51,19,34,51:2,15,23,17,18,24,44,51:2,43,3,29,4,13," +
"53,0:2")[0];

	private int yy_rmap[] = unpackFromString(1,159,
"0,1:7,2,3,4,5,6,7,1:2,8,1:2,9,10,11,12,1,13,14,1:3,15,1:5,16,1:7,17,1:10,17" +
",18,17:16,1,19,1:4,20,1:4,21,1,22,23,24,25,26,27,28,1:2,29,30,31:2,32,33,34" +
",35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59" +
",60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,17" +
",84,85,86,87,88,17,89,90")[0];

	private int yy_nxt[][] = unpackFromString(91,57,
"1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,133,134,156:2,86,116,156,135,117,147" +
",17,18,19,20,21,22,23,24,157,158,25,136,156:2,137,26,27,156,148,156:4,28,29" +
",156:2,30:2,3,30,-1:68,31,-1:52,32,-1,33,34,35,-1:19,85,-1:36,36,-1:21,37,-" +
"1:31,38,-1,39,40,-1:56,41,-1:56,42,-1:60,156,149,156:9,-1:8,156:2,-1,156:4," +
"-1:2,156:6,-1,150,156,150,-1:32,44,-1:57,45,-1:57,46,-1:37,47,-1:56,48,-1:2" +
"1,49,-1:34,50,-1:24,51,-1:70,29,-1:17,52,-1:60,156:11,-1:8,156:2,-1,156:4,-" +
"1:2,156:6,-1,150,156,150,-1:19,156,145,156:9,-1:8,156:2,-1,156:4,-1:2,156:6" +
",-1,150,156,150,-1:12,94,-1,97,-1:46,1,79,-1,89:10,-1,89,93:11,89:3,-1:2,89" +
":3,93:2,89,93:4,89:2,93:6,-1,93:3,-1,80,89:2,-1:50,83,-1:17,53,-1:60,156:4," +
"91,156,43,156:4,-1:8,156:2,-1,156:4,-1:2,156:6,-1,150,156,150,-1:6,92:6,75," +
"92,96,92:46,-1:2,92:6,-1,92,74,92:46,-1:3,89:10,-1,89,-1:11,89:3,-1:2,89:3," +
"-1:2,89,-1:4,89:2,-1:12,89:2,1,72,73:6,88,73,87,73:46,-1:15,156:2,54,156:8," +
"-1:8,156:2,-1,156:4,-1:2,156:6,-1,150,156,150,-1:6,92:6,-1,92,-1,92:46,-1:1" +
"5,55,156:10,-1:8,156:2,-1,156:4,-1:2,156:6,-1,150,156,150,-1:6,92:6,-1,92:4" +
"8,-1:15,56,156:10,-1:8,156:2,-1,156:4,-1:2,156:6,-1,150,156,150,-1:4,1,76,7" +
"7:55,-1:15,156,57,156:9,-1:8,156:2,-1,156:4,-1:2,156:6,-1,150,156,150,-1:4," +
"1,81,82,-1:47,83,-1:3,84,82,-1:16,156,58,156:9,-1:8,156:2,-1,156:4,-1:2,156" +
":6,-1,150,156,150,-1:19,156,59,156:9,-1:8,156:2,-1,156:4,-1:2,156:6,-1,150," +
"156,150,-1:19,156:11,-1:8,156:2,-1,156:4,-1:2,156:3,60,156:2,-1,150,156,150" +
",-1:19,156:11,-1:8,156:2,-1,156:2,61,156,-1:2,156:6,-1,150,156,150,-1:19,15" +
"6:7,62,156:3,-1:8,156:2,-1,156:4,-1:2,156:6,-1,150,156,150,-1:19,156,63,156" +
":9,-1:8,156:2,-1,156:4,-1:2,156:6,-1,150,156,150,-1:19,156:11,-1:8,156,64,-" +
"1,156:4,-1:2,156:6,-1,150,156,150,-1:19,156:11,-1:8,156:2,-1,156:4,-1:2,156" +
":5,65,-1,150,156,150,-1:19,156,66,156:9,-1:8,156:2,-1,156:4,-1:2,156:6,-1,1" +
"50,156,150,-1:19,156:4,67,156:6,-1:8,156:2,-1,156:4,-1:2,156:6,-1,150,156,1" +
"50,-1:19,156:2,68,156:8,-1:8,156:2,-1,156:4,-1:2,156:6,-1,150,156,150,-1:19" +
",156:2,69,156:8,-1:8,156:2,-1,156:4,-1:2,156:6,-1,150,156,150,-1:19,156:4,7" +
"0,156:6,-1:8,156:2,-1,156:4,-1:2,156:6,-1,150,156,150,-1:19,156,71,156:9,-1" +
":8,156:2,-1,156:4,-1:2,156:6,-1,150,156,150,-1:19,156:10,138,-1:8,95,156,-1" +
",156:4,-1:2,156:6,-1,150,156,150,-1:19,156:10,98,-1:8,121,156,-1,156:4,-1:2" +
",156:6,-1,150,156,150,-1:19,156:8,100,156:2,-1:8,156:2,-1,156:4,-1:2,156:6," +
"-1,150,156,150,-1:19,156:3,102,156:7,-1:8,156:2,-1,156:4,-1:2,156:6,-1,150," +
"156,150,-1:19,156:11,-1:8,156:2,-1,156:4,-1:2,103,156:5,-1,150,156,150,-1:1" +
"9,156:5,104,156:5,-1:8,156:2,-1,156:4,-1:2,156:6,-1,150,156,150,-1:19,156:1" +
"1,-1:8,156:2,-1,156:2,105,156,-1:2,156:6,-1,150,156,150,-1:19,156:11,-1:8,1" +
"06,156,-1,156:4,-1:2,156:6,-1,150,156,150,-1:19,156:8,107,156:2,-1:8,156:2," +
"-1,156:4,-1:2,156:6,-1,150,156,150,-1:19,156:11,-1:8,108,156,-1,156:4,-1:2," +
"156:6,-1,150,156,150,-1:19,156:10,109,-1:8,156:2,-1,156:4,-1:2,156:6,-1,150" +
",156,150,-1:19,156:7,110,156:3,-1:8,156:2,-1,156:4,-1:2,156:6,-1,150,156,15" +
"0,-1:19,111,156:10,-1:8,156:2,-1,156:4,-1:2,156:6,-1,150,156,150,-1:19,156:" +
"11,-1:8,156,112,-1,156:4,-1:2,156:6,-1,150,156,150,-1:19,156,113,156:9,-1:8" +
",156:2,-1,156:4,-1:2,156:6,-1,150,156,150,-1:19,156:11,-1:8,156:2,-1,156:4," +
"-1:2,156:4,114,156,-1,150,156,150,-1:19,156:3,115,156:7,-1:8,156:2,-1,156:4" +
",-1:2,156:6,-1,150,156,150,-1:19,156:7,118,156:3,-1:8,156:2,-1,156:4,-1:2,1" +
"56:6,-1,150,156,150,-1:19,119,156:10,-1:8,156:2,-1,156:4,-1:2,156:6,-1,150," +
"156,150,-1:19,156:2,151,156:2,120,156:5,-1:8,156:2,-1,156:4,-1:2,156:6,-1,1" +
"50,156,150,-1:19,156:11,-1:8,156:2,-1,156,122,156:2,-1:2,156:6,-1,150,156,1" +
"50,-1:19,140,156:10,-1:8,123,156,-1,156:4,-1:2,156:6,-1,150,156,150,-1:19,1" +
"56:7,124,156:3,-1:8,156:2,-1,156:4,-1:2,156:6,-1,150,156,150,-1:19,156:7,12" +
"5,156:3,-1:8,156:2,-1,156:4,-1:2,156:6,-1,150,156,150,-1:19,156,126,156:9,-" +
"1:8,156:2,-1,156:4,-1:2,156:6,-1,150,156,150,-1:19,156:5,127,156:5,-1:8,156" +
":2,-1,156:4,-1:2,156:6,-1,150,156,150,-1:19,156:3,128,156:7,-1:8,156:2,-1,1" +
"56:4,-1:2,156:6,-1,150,156,150,-1:19,156:3,129,156:7,-1:8,156:2,-1,156:4,-1" +
":2,156:6,-1,150,156,150,-1:19,156:8,130,156:2,-1:8,156:2,-1,156:4,-1:2,156:" +
"6,-1,150,156,150,-1:19,156:5,131,156:5,-1:8,156:2,-1,156:4,-1:2,156:6,-1,15" +
"0,156,150,-1:19,156:4,132,156:6,-1:8,156:2,-1,156:4,-1:2,156:6,-1,150,156,1" +
"50,-1:19,156:7,139,156:3,-1:8,156:2,-1,156:4,-1:2,156:6,-1,150,156,150,-1:1" +
"9,156:11,-1:8,156:2,-1,156:4,-1:2,156:2,141,156:3,-1,150,156,150,-1:19,156:" +
"2,142,156:8,-1:8,156:2,-1,156:4,-1:2,156:6,-1,150,156,150,-1:19,143,156:10," +
"-1:8,156:2,-1,156:4,-1:2,156:6,-1,150,156,150,-1:19,156:6,144,156:4,-1:8,15" +
"6:2,-1,156:4,-1:2,156:6,-1,150,156,150,-1:19,156:4,154,156:6,-1:8,156:2,-1," +
"156:4,-1:2,156:6,-1,150,156,150,-1:19,156:2,155,156:8,-1:8,156:2,-1,156:4,-" +
"1:2,156:6,-1,150,156,150,-1:19,156:5,146,156:5,-1:8,156:2,-1,156:4,-1:2,156" +
":6,-1,150,156,150,-1:19,156:6,152,156:4,-1:8,156:2,-1,156:4,-1:2,156:6,-1,1" +
"50,156,150,-1:19,156:11,-1:8,153,156,-1,156:4,-1:2,156:6,-1,150,156,150,-1:" +
"4");

	public java_cup.runtime.Symbol nextToken ()
		throws java.io.IOException {
		int yy_lookahead;
		int yy_anchor = YY_NO_ANCHOR;
		int yy_state = yy_state_dtrans[yy_lexical_state];
		int yy_next_state = YY_NO_STATE;
		int yy_last_accept_state = YY_NO_STATE;
		boolean yy_initial = true;
		int yy_this_accept;

		yy_mark_start();
		yy_this_accept = yy_acpt[yy_state];
		if (YY_NOT_ACCEPT != yy_this_accept) {
			yy_last_accept_state = yy_state;
			yy_mark_end();
		}
		while (true) {
			if (yy_initial && yy_at_bol) yy_lookahead = YY_BOL;
			else yy_lookahead = yy_advance();
			yy_next_state = YY_F;
			yy_next_state = yy_nxt[yy_rmap[yy_state]][yy_cmap[yy_lookahead]];
			if (YY_EOF == yy_lookahead && true == yy_initial) {

	{
	 return tok(sym.EOF, null);
        }
			}
			if (YY_F != yy_next_state) {
				yy_state = yy_next_state;
				yy_initial = false;
				yy_this_accept = yy_acpt[yy_state];
				if (YY_NOT_ACCEPT != yy_this_accept) {
					yy_last_accept_state = yy_state;
					yy_mark_end();
				}
			}
			else {
				if (YY_NO_STATE == yy_last_accept_state) {
					throw (new Error("Lexical Error: Unmatched Input."));
				}
				else {
					yy_anchor = yy_acpt[yy_last_accept_state];
					if (0 != (YY_END & yy_anchor)) {
						yy_move_end();
					}
					yy_to_mark();
					switch (yy_last_accept_state) {
					case 1:
						
					case -2:
						break;
					case 2:
						{ newline(); }
					case -3:
						break;
					case 3:
						{ }
					case -4:
						break;
					case 4:
						{ return tok(sym.LBRACE, null); }
					case -5:
						break;
					case 5:
						{ return tok(sym.RBRACE, null); }
					case -6:
						break;
					case 6:
						{ return tok(sym.LPAREN, null); }
					case -7:
						break;
					case 7:
						{ return tok(sym.RPAREN, null); }
					case -8:
						break;
					case 8:
						{ return tok(sym.PLUS, null); }
					case -9:
						break;
					case 9:
						{ return tok(sym.TIMES, null); }
					case -10:
						break;
					case 10:
						{ return tok(sym.MINUS, null); }
					case -11:
						break;
					case 11:
						{ return tok(sym.DIVIDE, null); }
					case -12:
						break;
					case 12:
						{ return tok(sym.ASSIGN, null); }
					case -13:
						break;
					case 13:
						{ return tok(sym.MOD, null); }
					case -14:
						break;
					case 14:
						{ return tok(sym.BNOT, null); }
					case -15:
						break;
					case 15:
						{ return tok(sym.SEMICOL, null); }
					case -16:
						break;
					case 16:
						{ return tok(sym.ID, yytext()); }
					case -17:
						break;
					case 17:
						{ return tok(sym.COLON, null); }
					case -18:
						break;
					case 18:
						{ return tok(sym.COMMA, null); }
					case -19:
						break;
					case 19:
						{ return tok(sym.BAND, null); }
					case -20:
						break;
					case 20:
						{ return tok(sym.BOR, null); }
					case -21:
						break;
					case 21:
						{ return tok(sym.BXOR, null); }
					case -22:
						break;
					case 22:
						{ return tok(sym.BOOLNOT, null); }
					case -23:
						break;
					case 23:
						{ return tok(sym.DOT, null); }
					case -24:
						break;
					case 24:
						{ return tok(sym.GREATERTHAN, null); }
					case -25:
						break;
					case 25:
						{ return tok(sym.LESSTHAN, null); }
					case -26:
						break;
					case 26:
						{ return tok(sym.LBRACKET, null); }
					case -27:
						break;
					case 27:
						{ return tok(sym.RBRACKET, null); }
					case -28:
						break;
					case 28:
						{ yybegin(CPPDESC); }
					case -29:
						break;
					case 29:
						{ return tok(sym.INT, yytext()); }
					case -30:
						break;
					case 30:
						{
        err("Illegal character: <" + yytext() + ">");
}
					case -31:
						break;
					case 31:
						{ return tok(sym.PLUSASSIGN, null); }
					case -32:
						break;
					case 32:
						{ return tok(sym.PPLUS, null); }
					case -33:
						break;
					case 33:
						{ return tok(sym.PMINUS, null); }
					case -34:
						break;
					case 34:
						{
        err("Unbalanced comment");
}
					case -35:
						break;
					case 35:
						{ return tok(sym.TIMESASSIGN, null); }
					case -36:
						break;
					case 36:
						{ return tok(sym.MINUSASSIGN, null); }
					case -37:
						break;
					case 37:
						{ return tok(sym.ARROW, null); }
					case -38:
						break;
					case 38:
						{  yybegin(COMMENT); comment_count = comment_count + 1; }
					case -39:
						break;
					case 39:
						{ yybegin(LINECOMMENT); }
					case -40:
						break;
					case 40:
						{ return tok(sym.DIVIDEASSIGN, null); }
					case -41:
						break;
					case 41:
						{ return tok(sym.EQUAL, null); }
					case -42:
						break;
					case 42:
						{ return tok(sym.MODASSIGN, null); }
					case -43:
						break;
					case 43:
						{ return tok(sym.IF, null); }
					case -44:
						break;
					case 44:
						{ return tok(sym.BOOLAND, null); }
					case -45:
						break;
					case 45:
						{ return tok(sym.BOOLOR, null); }
					case -46:
						break;
					case 46:
						{ return tok(sym.BOOLXOR, null); }
					case -47:
						break;
					case 47:
						{ return tok(sym.NOTEQUAL, null); }
					case -48:
						break;
					case 48:
						{ return tok(sym.GREATERTHANOREQUAL, null); }
					case -49:
						break;
					case 49:
						{ return tok(sym.RSHIFT, null); }
					case -50:
						break;
					case 50:
						{ return tok(sym.LESSTHANOREQUAL, null); }
					case -51:
						break;
					case 51:
						{ return tok(sym.LSHIFT, null); }
					case -52:
						break;
					case 52:
						{ return tok(sym.PEQUAL, null); }
					case -53:
						break;
					case 53:
						{ return tok(sym.PNOTEQUAL, null); }
					case -54:
						break;
					case 54:
						{ return tok(sym.DINT, null); }
					case -55:
						break;
					case 55:
						{ return tok(sym.FOR, null); }
					case -56:
						break;
					case 56:
						{ return tok(sym.VAR, null); }
					case -57:
						break;
					case 57:
						{ return tok(sym.ELSE, null); }
					case -58:
						break;
					case 58:
						{ return tok(sym.TRUE, null); }
					case -59:
						break;
					case 59:
						{ return tok(sym.SIZE, null); }
					case -60:
						break;
					case 60:
						{ return tok(sym.VOID, null); }
					case -61:
						break;
					case 61:
						{ return tok(sym.NULL, null); }
					case -62:
						break;
					case 62:
						{ return tok(sym.DBOOL, null); }
					case -63:
						break;
					case 63:
						{ return tok(sym.FALSE, null); }
					case -64:
						break;
					case 64:
						{ return tok(sym.ALLOC, null); }
					case -65:
						break;
					case 65:
						{ return tok(sym.BREAK, null); }
					case -66:
						break;
					case 66:
						{ return tok(sym.WHILE, null); }
					case -67:
						break;
					case 67:
						{ return tok(sym.RETURN, null); }
					case -68:
						break;
					case 68:
						{ return tok(sym.STRUCT, null); }
					case -69:
						break;
					case 69:
						{ return tok(sym.OFFSET, null); }
					case -70:
						break;
					case 70:
						{ return tok(sym.FOREIGN, null); }
					case -71:
						break;
					case 71:
						{ return tok(sym.CONTINUE, null); }
					case -72:
						break;
					case 72:
						{ newline(); }
					case -73:
						break;
					case 73:
						{  }
					case -74:
						break;
					case 74:
						{ 
	comment_count = comment_count - 1; 
	if (comment_count == 0) {
    		yybegin(YYINITIAL);
	}
}
					case -75:
						break;
					case 75:
						{ comment_count = comment_count + 1; }
					case -76:
						break;
					case 76:
						{ newline(); yybegin(YYINITIAL); }
					case -77:
						break;
					case 77:
						{ }
					case -78:
						break;
					case 78:
						{ filename += yytext(); }
					case -79:
						break;
					case 79:
						{ newline(); }
					case -80:
						break;
					case 80:
						{ outfile(filename); errorMsg.newfile(filename, last_linenumber); yybegin(CPPDESC); }
					case -81:
						break;
					case 81:
						{ newline(); yybegin(YYINITIAL); }
					case -82:
						break;
					case 82:
						{ }
					case -83:
						break;
					case 83:
						{ last_linenumber = Integer.parseInt(yytext()); }
					case -84:
						break;
					case 84:
						{ filename = ""; yybegin(FILENAME); }
					case -85:
						break;
					case 86:
						{ return tok(sym.ID, yytext()); }
					case -86:
						break;
					case 87:
						{
        err("Illegal character: <" + yytext() + ">");
}
					case -87:
						break;
					case 88:
						{  }
					case -88:
						break;
					case 89:
						{ filename += yytext(); }
					case -89:
						break;
					case 91:
						{ return tok(sym.ID, yytext()); }
					case -90:
						break;
					case 92:
						{  }
					case -91:
						break;
					case 93:
						{ filename += yytext(); }
					case -92:
						break;
					case 95:
						{ return tok(sym.ID, yytext()); }
					case -93:
						break;
					case 96:
						{  }
					case -94:
						break;
					case 98:
						{ return tok(sym.ID, yytext()); }
					case -95:
						break;
					case 100:
						{ return tok(sym.ID, yytext()); }
					case -96:
						break;
					case 102:
						{ return tok(sym.ID, yytext()); }
					case -97:
						break;
					case 103:
						{ return tok(sym.ID, yytext()); }
					case -98:
						break;
					case 104:
						{ return tok(sym.ID, yytext()); }
					case -99:
						break;
					case 105:
						{ return tok(sym.ID, yytext()); }
					case -100:
						break;
					case 106:
						{ return tok(sym.ID, yytext()); }
					case -101:
						break;
					case 107:
						{ return tok(sym.ID, yytext()); }
					case -102:
						break;
					case 108:
						{ return tok(sym.ID, yytext()); }
					case -103:
						break;
					case 109:
						{ return tok(sym.ID, yytext()); }
					case -104:
						break;
					case 110:
						{ return tok(sym.ID, yytext()); }
					case -105:
						break;
					case 111:
						{ return tok(sym.ID, yytext()); }
					case -106:
						break;
					case 112:
						{ return tok(sym.ID, yytext()); }
					case -107:
						break;
					case 113:
						{ return tok(sym.ID, yytext()); }
					case -108:
						break;
					case 114:
						{ return tok(sym.ID, yytext()); }
					case -109:
						break;
					case 115:
						{ return tok(sym.ID, yytext()); }
					case -110:
						break;
					case 116:
						{ return tok(sym.ID, yytext()); }
					case -111:
						break;
					case 117:
						{ return tok(sym.ID, yytext()); }
					case -112:
						break;
					case 118:
						{ return tok(sym.ID, yytext()); }
					case -113:
						break;
					case 119:
						{ return tok(sym.ID, yytext()); }
					case -114:
						break;
					case 120:
						{ return tok(sym.ID, yytext()); }
					case -115:
						break;
					case 121:
						{ return tok(sym.ID, yytext()); }
					case -116:
						break;
					case 122:
						{ return tok(sym.ID, yytext()); }
					case -117:
						break;
					case 123:
						{ return tok(sym.ID, yytext()); }
					case -118:
						break;
					case 124:
						{ return tok(sym.ID, yytext()); }
					case -119:
						break;
					case 125:
						{ return tok(sym.ID, yytext()); }
					case -120:
						break;
					case 126:
						{ return tok(sym.ID, yytext()); }
					case -121:
						break;
					case 127:
						{ return tok(sym.ID, yytext()); }
					case -122:
						break;
					case 128:
						{ return tok(sym.ID, yytext()); }
					case -123:
						break;
					case 129:
						{ return tok(sym.ID, yytext()); }
					case -124:
						break;
					case 130:
						{ return tok(sym.ID, yytext()); }
					case -125:
						break;
					case 131:
						{ return tok(sym.ID, yytext()); }
					case -126:
						break;
					case 132:
						{ return tok(sym.ID, yytext()); }
					case -127:
						break;
					case 133:
						{ return tok(sym.ID, yytext()); }
					case -128:
						break;
					case 134:
						{ return tok(sym.ID, yytext()); }
					case -129:
						break;
					case 135:
						{ return tok(sym.ID, yytext()); }
					case -130:
						break;
					case 136:
						{ return tok(sym.ID, yytext()); }
					case -131:
						break;
					case 137:
						{ return tok(sym.ID, yytext()); }
					case -132:
						break;
					case 138:
						{ return tok(sym.ID, yytext()); }
					case -133:
						break;
					case 139:
						{ return tok(sym.ID, yytext()); }
					case -134:
						break;
					case 140:
						{ return tok(sym.ID, yytext()); }
					case -135:
						break;
					case 141:
						{ return tok(sym.ID, yytext()); }
					case -136:
						break;
					case 142:
						{ return tok(sym.ID, yytext()); }
					case -137:
						break;
					case 143:
						{ return tok(sym.ID, yytext()); }
					case -138:
						break;
					case 144:
						{ return tok(sym.ID, yytext()); }
					case -139:
						break;
					case 145:
						{ return tok(sym.ID, yytext()); }
					case -140:
						break;
					case 146:
						{ return tok(sym.ID, yytext()); }
					case -141:
						break;
					case 147:
						{ return tok(sym.ID, yytext()); }
					case -142:
						break;
					case 148:
						{ return tok(sym.ID, yytext()); }
					case -143:
						break;
					case 149:
						{ return tok(sym.ID, yytext()); }
					case -144:
						break;
					case 150:
						{ return tok(sym.ID, yytext()); }
					case -145:
						break;
					case 151:
						{ return tok(sym.ID, yytext()); }
					case -146:
						break;
					case 152:
						{ return tok(sym.ID, yytext()); }
					case -147:
						break;
					case 153:
						{ return tok(sym.ID, yytext()); }
					case -148:
						break;
					case 154:
						{ return tok(sym.ID, yytext()); }
					case -149:
						break;
					case 155:
						{ return tok(sym.ID, yytext()); }
					case -150:
						break;
					case 156:
						{ return tok(sym.ID, yytext()); }
					case -151:
						break;
					case 157:
						{ return tok(sym.ID, yytext()); }
					case -152:
						break;
					case 158:
						{ return tok(sym.ID, yytext()); }
					case -153:
						break;
					default:
						yy_error(YY_E_INTERNAL,false);
					case -1:
					}
					yy_initial = true;
					yy_state = yy_state_dtrans[yy_lexical_state];
					yy_next_state = YY_NO_STATE;
					yy_last_accept_state = YY_NO_STATE;
					yy_mark_start();
					yy_this_accept = yy_acpt[yy_state];
					if (YY_NOT_ACCEPT != yy_this_accept) {
						yy_last_accept_state = yy_state;
						yy_mark_end();
					}
				}
			}
		}
	}
}
